import random
import one_five_dict

prompt_to_optimize = '''
Accurately assess this individual's alignment with the provided statements, and determine the best matching response based on the exemplars.
'''

instruction_prompt = '''
A person says this about themselves:
'''

prompt_answer_format = '''
Respond with a single number between 1 and 5 and then terminate the answer.
'''


class PromptBuilding:

    def get_mapping_prompt(self, personality_statement, current_question, num_statements, optimized_prompt):

        teil_3 = f'''            
Consider this scale:
1 = Disagree
2 = Somewhat Disagree
3 = Neutral
4 = Somewhat Agree
5 = Agree'''

        teil_2=f'''
New statement to predict:
{current_question}
'''

        teil_1 = "A person says this about themselves:\n"

        teil_4 = '''
Predict how the person would rate themselves on the new statement.
Provide a single number between 1 and 5, then end the response.
'''

        random.seed(42)

        for statement in random.sample(personality_statement, num_statements):
            teil_1 = teil_1 + f"{statement} \n"

        return ( teil_1
                + teil_2
                + teil_3
                + teil_4
                )


    def get_number_prompt(self, prev_questions, prev_answers, current_question, num_statements, optimized_prompt):

        teil_3 = \
            f'''
            
Consider this scale:
1 = Disagree
2 = Somewhat Disagree
3 = Neutral
4 = Somewhat Agree
5 = Agree
'''
        teil_2 = f'''          
New statement to predict:
{current_question}
'''

        teil_4 = f'''
{optimized_prompt}
Provide a single number between 1 and 5, then end the response.
'''

        teil_1 = ""

        q_a = list(zip(prev_questions, prev_answers))

        random.seed(42)

        sample_q_a = random.sample(q_a, num_statements)

        for question, answer in sample_q_a:
            answer_text = one_five_dict.dict_one_five[answer]
            teil_1 = teil_1 + f"Question: '{question}' Answer:'{answer_text}'\n"
        teil_1 = instruction_prompt + teil_1

        return teil_1 + teil_2  + teil_3 + teil_4